"{ Package: 'cvut:stx/goodies/libsvn' }"

"{ NameSpace: SVN }"

ApplicationModel subclass:#Browser
	instanceVariableNames:'modelHolder selectionHolder'
	classVariableNames:''
	poolDictionaries:''
	category:'SVN-UI-Browsers'
!


!Browser class methodsFor:'instance creation'!

on: aWorkingCopy

    ^self new 
        model: aWorkingCopy;
        yourself

    "Created: / 14-04-2008 / 11:09:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Browser class methodsFor:'interface opening'!

openOn: aWorkingCopy

    ^(self on: aWorkingCopy) open

    "Created: / 14-04-2008 / 11:09:18 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Browser class methodsFor:'plugIn spec'!

aspectSelectors

    ^ #(
        #model
      ).

    "Created: / 12-04-2008 / 21:04:10 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Browser methodsFor:'accessing'!

model
    ^self modelHolder value

    "Modified: / 20-04-2005 / 18:59:28 / janfrog"
    "Created: / 12-04-2008 / 21:01:04 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

model:aModel
    self modelHolder subjectChannel:aModel
    "aModel isValueModel 
        ifTrue:[self modelHolder subjectChannel:aModel]
        ifFalse:[self modelHolder subject:aModel]."

    "Modified: / 20-04-2005 / 18:59:28 / janfrog"
    "Created: / 12-04-2008 / 21:01:04 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

selection

    ^self selectionHolder value

    "Created: / 22-10-2008 / 11:30:03 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

selection: selection

    ^self selectionHolder value: selection

    "Created: / 22-10-2008 / 11:30:11 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Browser methodsFor:'accessing - defaults'!

defaultSelection

    ^nil

    "Created: / 22-10-2008 / 11:28:05 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Browser methodsFor:'aspects'!

hasSelectionHolder

    |holder|

    (holder := builder bindingAt:#hasSelectionHolder) isNil ifTrue:[
        holder := (AspectAdaptor forAspect: #notEmptyOrNil)
            subjectChannel: self selectionHolder.
        builder aspectAt:#hasSelectionHolder put: holder
    ].
    ^ holder.

    "Created: / 22-10-2008 / 11:34:36 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 22-10-2008 / 12:38:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

modelHolder
    ^modelHolder ifNil:[
        modelHolder := (AspectAdaptor subjectChannel:nil)
                            forAspect:#value
    ]

    "Modified: / 20-04-2005 / 18:59:28 / janfrog"
    "Created: / 12-04-2008 / 21:01:04 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

selectionHolder
    selectionHolder ifNil:[
        selectionHolder := self defaultSelection asValue.
        selectionHolder onChangeSend: #selectionChanged to: self.
    ].
    ^selectionHolder

    "Modified: / 20-04-2005 / 18:59:28 / janfrog"
    "Created: / 22-10-2008 / 11:28:05 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

selectionHolder:aValueHolder
    selectionHolder := aValueHolder.
! !

!Browser methodsFor:'change & update'!

selectionChanged

    "nothing to do"

    "Created: / 22-10-2008 / 11:29:24 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Browser methodsFor:'initialization'!

initialize

    super initialize.
    self createBuilder

    "Created: / 22-10-2008 / 12:37:14 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Browser methodsFor:'queries'!

hasSelection

    ^self selection notEmptyOrNil

    "Created: / 22-10-2008 / 12:23:29 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Browser class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
!

version_SVN
    ^'Id: SVN__Browser.st 68 2009-04-16 11:35:57Z vranyj1 '
! !
