"{ Package: 'cvut:stx/goodies/libsvn' }"

"{ NameSpace: SVN }"

Entry subclass:#RepositoryEntry
	instanceVariableNames:'size branch'
	classVariableNames:''
	poolDictionaries:''
	category:'SVN-Repository'
!


!RepositoryEntry class methodsFor:'instance creation'!

readFromXml: anXMLNode

    ^self new readFromXml: anXMLNode

    "Created: / 18-08-2009 / 17:24:10 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 19-08-2009 / 08:51:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!RepositoryEntry methodsFor:'accessing'!

branch
    ^ branch
! !

!RepositoryEntry methodsFor:'initialization'!

readFromXml: anXMLNode

    kind := (NodeKind withName: anXMLNode @ 'kind').
    path := (anXMLNode / 'name') characterData.
    revision := Revision number: ((anXMLNode / 'commit' ) first @ 'revision').
    date := Timestamp readISO8601From: (anXMLNode / 'commit' / 'date') characterData.
    author := (anXMLNode / 'commit' / 'author') characterData.
    size := (anXMLNode / 'size') characterData.
    size isNilOrEmptyCollection ifFalse:[size := size asInteger]

    "Created: / 19-08-2009 / 08:52:10 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 19-08-2009 / 15:07:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

setBranch: aBranch

    branch := aBranch

    "Created: / 18-08-2009 / 13:15:16 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!RepositoryEntry class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
!

version_SVN
    ^'Id: SVN__RepositoryEntry.st 111 2009-08-19 20:07:10Z vranyj1 '
! !
